<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		downloads
 */

class Block_main_download_category
{

	/**
	 * Standard modular info function.
	 *
	 * @return ?array	Map of module info (NULL: module is disabled).
	 */
	function info()
	{
		$info=array();
		$info['author']='Chris Graham';
		$info['organisation']='ocProducts';
		$info['hacked_by']=NULL;
		$info['hack_version']=NULL;
		$info['version']=2;
		$info['locked']=false;
		$info['parameters']=array('param','title','order','cat_order');
		return $info;
	}

	/**
	 * Standard modular cache function.
	 *
	 * @return ?array	Map of cache details (cache_on and ttl) (NULL: module is disabled).
	 */
	function cacheing_environment()
	{
		$info=array();
		$info['cache_on']='array(get_param_integer(\'max\',30),get_param_integer(\'start\',0),$GLOBALS[\'FORUM_DRIVER\']->get_members_groups(get_member(),false,true),array_key_exists(\'order\',$map)?$map[\'order\']:NULL,array_key_exists(\'cat_order\',$map)?$map[\'cat_order\']:NULL,array_key_exists(\'title\',$map)?$map[\'title\']:do_lang(\'downloads:SECTION_DOWNLOADS\'),array_key_exists(\'param\',$map)?intval($map[\'param\']):db_get_first_id())';
		$info['ttl']=60;
		return $info;
	}

	/**
	 * Standard modular run function.
	 *
	 * @param  array		A map of parameters.
	 * @return tempcode	The result of execution.
	 */
	function run($map)
	{
		require_code('downloads');
		require_css('downloads');
		require_lang('downloads');

		$category_id=array_key_exists('param',$map)?intval($map['param']):db_get_first_id();
		$title=array_key_exists('title',$map)?$map['title']:do_lang('SECTION_DOWNLOADS');

		$order=array_key_exists('order',$map)?$map['order']:NULL;
		$cat_order=array_key_exists('cat_order',$map)?$map['cat_order']:NULL;
		if ((!is_null($order)) && (strpos($order,' ')===false)) $order.=' ASC';
		if ((!is_null($cat_order)) && (strpos($cat_order,' ')===false)) $cat_order.=' ASC';
		if (!is_null($order))
		{
			if (($order!='t.text_original ASC') && ($order!='t.text_original DESC') && ($order!='t.text_original ASC') && ($order!='t.text_original DESC') && ($order!='file_size ASC') && ($order!='file_size DESC')
				&& ($order!='num_downloads DESC') && ($order!='add_date ASC')
				&& ($order!='add_date DESC')) $order=NULL;
		}
		if (!is_null($cat_order))
		{
			if (($cat_order!='t.text_original ASC') && ($cat_order!='t.text_original DESC') && ($cat_order!='add_date ASC') && ($order!='add_date DESC')) $cat_order=NULL;
		}
		$subcategories=get_download_sub_categories($category_id,NULL,NULL,$cat_order);
		$downloads=get_category_downloads($category_id,$category_id,$order);
		if (($subcategories->is_empty()) && ($downloads->is_empty()))
		{
			if ((has_actual_page_access(NULL,'cms_downloads',NULL,NULL)) && (has_submit_permission('mid',get_member(),get_ip_address(),'cms_downloads')))
			{
				$submit_url=build_url(array('page'=>'cms_downloads','type'=>'ad','cat'=>$category_id,'redirect'=>SELF_REDIRECT),get_module_zone('cms_downloads'));
			} else $submit_url=new ocp_tempcode();
			return do_template('BLOCK_NO_ENTRIES',array('_GUID'=>'1e7be43cf5074821854d64458202b09d','HIGH'=>false,'TITLE'=>$title,'MESSAGE'=>do_lang_tempcode('NO_ENTRIES'),'ADD_NAME'=>do_lang_tempcode('ADD_DOWNLOAD'),'SUBMIT_URL'=>$submit_url));
		}
		$submit_url=new ocp_tempcode();
		if ((has_actual_page_access(NULL,'cms_downloads',NULL,NULL)) && (has_submit_permission('high',get_member(),get_ip_address(),'cms_downloads')))
		{
			$submit_url=build_url(array('page'=>'cms_downloads','type'=>'ad','cat'=>$category_id,'redirect'=>SELF_REDIRECT),get_module_zone('cms_downloads'));
		}
		return do_template('BLOCK_MAIN_DOWNLOAD_CATEGORY',array('_GUID'=>'518c63ef968e3b452d3b5cfa2e9505ec','SUBMIT_URL'=>$submit_url,'SUBCATEGORIES'=>$subcategories,'DOWNLOADS'=>$downloads,'TITLE'=>$title));
	}

}


