<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		galleries
 */

class Block_main_top_galleries
{

	/**
	 * Standard modular info function.
	 *
	 * @return ?array	Map of module info (NULL: module is disabled).
	 */
	function info()
	{
		$info=array();
		$info['author']='Chris Graham';
		$info['organisation']='ocProducts';
		$info['hacked_by']=NULL;
		$info['hack_version']=NULL;
		$info['version']=2;
		$info['locked']=false;
		$info['parameters']=array('param','zone');
		return $info;
	}

	/**
	 * Standard modular cache function.
	 *
	 * @return ?array	Map of cache details (cache_on and ttl) (NULL: module is disabled).
	 */
	function cacheing_environment()
	{
		$info=array();
		$info['cache_on']='array(array_key_exists(\'param\',$map)?intval($map[\'param\']):10,array_key_exists(\'zone\',$map)?$map[\'zone\']:get_module_zone(\'galleries\'))';
		$info['ttl']=60*24;
		return $info;
	}

	/**
	 * Standard modular run function.
	 *
	 * @param  array		A map of parameters.
	 * @return tempcode	The result of execution.
	 */
	function run($map)
	{
		require_code('galleries');
		require_lang('galleries');
		require_css('galleries');

		$number=array_key_exists('param',$map)?intval($map['param']):10;
		$zone=array_key_exists('zone',$map)?$map['zone']:get_module_zone('galleries');

		$rows_all=collapse_2d_complexity('rating_for_id','sum_rating',$GLOBALS['SITE_DB']->query('SELECT rating_for_id,AVG(rating) AS sum_rating FROM '.get_table_prefix().'rating WHERE '.db_string_equal_to('rating_for_type','galleries').' GROUP BY rating_for_id'));
		arsort($rows_all);
		$rows=array();
		$highest=NULL;
		foreach ($rows_all as $id=>$avg)
		{
			if (is_null($highest)) $highest=$avg;

			if ($avg==$highest)
			{
				$rows[]=$id;
				unset($rows_all[$id]);
			} else break;
		}
		shuffle($rows);
		$rows+=array_keys($rows_all);

		$out=new ocp_tempcode();

		$galleries=NULL;
		if (count($rows)==0) // None rated
		{
			$galleries=$GLOBALS['SITE_DB']->query('SELECT * FROM '.get_table_prefix().'galleries WHERE name NOT LIKE \''.db_encode_like('download\_%').'\'',$number);
			foreach ($galleries as $gallery)
			{
				$rows[]=$gallery['name'];
			}
		}

		if (count($rows)==0)
		{
			return do_template('BLOCK_NO_ENTRIES',array('_GUID'=>'29a81617f7d4ce3384d519e9fe239178','HIGH'=>false,'TITLE'=>do_lang_tempcode('TOP',make_string_tempcode(integer_format($number)),do_lang_tempcode('GALLERIES')),'MESSAGE'=>do_lang_tempcode('NO_CATEGORIES'),'ADD_NAME'=>'','SUBMIT_URL'=>''));
		} else
		{
			if (is_null($galleries)) // Some rated. Mass load the top of those ones in one go
			{
				$i=0;
				$or_list='';
				foreach ($rows as $id)
				{
					if ($or_list!='') $or_list.=' OR ';
					$or_list.=db_string_equal_to('name',$id);

					if ($i==$number) break;

					$i++;
				}
				$galleries=$GLOBALS['SITE_DB']->query('SELECT * FROM '.get_table_prefix().'galleries WHERE ('.$or_list.') AND name NOT LIKE \''.db_encode_like('download\_%').'\'');
			}

			$i=0;
			foreach ($rows as $id)
			{
				$row=NULL;
				foreach ($galleries as $gallery)
				{
					if ($gallery['name']==$id)
					{
						$row=$gallery;
						break;
					}
				}

				if (!is_null($row))
				{
					$out->attach(do_template('GALLERY_SUBGALLERY_WRAP',array('CONTENT'=>show_gallery_box($row,'root',true,$zone,false,true))));
					if ($i==$number) break;
					$i++;
				}
			}
		}

		return do_template('BLOCK_MAIN_TOP_GALLERIES',array('_GUID'=>'f95e3288fe9bee2bcdd62b46cff15208','CONTENT'=>$out,'NUMBER'=>integer_format($number)));
	}

}


